/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package xbot;

import java.util.Arrays;
import xcastbot.ui.XCastPlantFarm;
import xcraftbot.ui.MarketplaceUI;
import xcraftbot.ui.SwingUI2;
import xcraftbot.ui.XCastHealthFarm;
import xcraftbot.ui.XCastOkariFarm;

public class MainLauncher {
    public static void main(String[] args) {
        if (args.length == 0) {
            System.out.println("Please specify as parameter what you want to launch:");
            System.out.println("  (1) XCastPlantFarm");
            System.out.println("  (2) MarketplaceUI");
            System.out.println("  (3) SwingUI2");
            System.out.println("  (4) XCastHealthFarm");
            System.out.println("  (5) XCastOkariFarm");
            return;
        }
        
        switch (args[0]) {
            case "1" -> XCastPlantFarm.main(Arrays.copyOfRange(args, 1, args.length));
            case "2" -> MarketplaceUI.main(Arrays.copyOfRange(args, 1, args.length));
            case "3" -> SwingUI2.main(Arrays.copyOfRange(args, 1, args.length));
            case "4" -> XCastHealthFarm.main(Arrays.copyOfRange(args, 1, args.length));
            case "5" -> XCastOkariFarm.main(Arrays.copyOfRange(args, 1, args.length));
            default -> System.out.println("Unknown selection: " + args[0]);
        }
    }
}
