/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package xcraftbot.ui;

import io.github.bonigarcia.wdm.WebDriverManager;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JProgressBar;
import javax.swing.JTextField;
import org.openqa.selenium.By;
import org.openqa.selenium.JavascriptExecutor;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.chrome.ChromeDriver;
import org.openqa.selenium.support.ui.WebDriverWait;
import xcastbot.ui.MainFrame;
import xcraftbot.logic.ButtonNavigate;
import xcraftbot.logic.Textbox;

/**
 *
 * @author agreiner
 */
public class MarketplaceUI {
    
    private String name;
    private String password;
    
    public MarketplaceUI(){
        
    }
    
    public static void main(String[] args) {
        MarketplaceUI ui = new MarketplaceUI();
        ui.showLoginFrame();
    }
    
    
    public void MarketplaceUI2(){
        WebDriverManager.chromedriver().setup();
        WebDriver driver = new ChromeDriver();
        
        JFrame frame = new JFrame("Marketplace");
        
        frame.setSize(300, 600);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        JPanel panel = new JPanel();
        
        JTextField txtSearch = new JTextField();
        txtSearch.setBounds(100, 510, 100, 30);
        JButton btnStart = new JButton("Start");
        btnStart.setBounds(100, 430, 100, 30);
        
        
        btnStart.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                driver.navigate().refresh();
                for(;;){
                    try{
                        WebElement elem = driver.findElement(By.xpath("//*[contains(text(), '"+txtSearch.getText()+"')]"));
                        System.out.println(elem.getText());
                        if (driver instanceof JavascriptExecutor) {
                            ((JavascriptExecutor)driver).executeScript("arguments[0].style.border='3px solid red'", elem);
                        }
                        break;
                    }catch(Exception ex){
                        driver.navigate().refresh();
                    }
                    
                }
                
            }
        });
        
        
        
        JTextField txtName = new JTextField();
        txtName.setBounds(100,100,100,30);
        JPasswordField pw = new JPasswordField();
        pw.setBounds(100,150,100,30);
        JButton btnLogin = new JButton("Login");
        btnLogin.setBounds(100,200, 100, 30);
        btnLogin.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                driver.get("https://xcraftkkrieger.cx.edvschule-plattling.de/XCraft/");
                WebElement boxName = driver.findElement(By.name(Textbox.USERNAME.getNameString()));
                boxName.sendKeys(txtName.getText());
                WebElement boxPassword = driver.findElement(By.name(Textbox.PASSWORD.getNameString()));
                boxPassword.sendKeys(pw.getText());
                WebElement btnLogin = driver.findElement(By.name(ButtonNavigate.LOGIN.getNameString()));
                btnLogin.click();
            }
        });
        
        panel.setLayout(null);
        panel.add(txtName);
        panel.add(pw);
        panel.add(btnLogin);
        panel.add(btnStart);
        panel.add(txtSearch);
        
        frame.add(panel);
        frame.setVisible(true);
        
        
        
        
        
        frame.setVisible(true);
    }
    
    public void showLoginFrame(){
        WebDriverManager.chromedriver().setup();
        WebDriver driver = new ChromeDriver();
        
        JFrame frameLogin = new JFrame("Login");
        frameLogin.setSize(300, 300);
        frameLogin.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        JPanel panelLogin = new JPanel();
        panelLogin.setLayout(null);
        
        JLabel lblName = new JLabel("Name:");
        JTextField txtName = new JTextField();
        JLabel lblPassword = new JLabel("Password:");
        JPasswordField txtPassword = new JPasswordField();
        JButton btnBotLogin = new JButton("Login");
        JLabel lblMessage = new JLabel("");
        
        lblName.setBounds(10, 10, 100, 30);
        txtName.setBounds(120, 10, 100, 30);
        lblPassword.setBounds(10, 50, 100, 30);
        txtPassword.setBounds(120,50,100,30);
        btnBotLogin.setBounds(10, 90, 210, 30);
        lblMessage.setBounds(10,130,210,30);
        
        lblMessage.setForeground(Color.RED);
        
        panelLogin.add(lblName);
        panelLogin.add(txtName);
        panelLogin.add(lblPassword);
        panelLogin.add(txtPassword);
        panelLogin.add(btnBotLogin);
        panelLogin.add(lblMessage);
        
        btnBotLogin.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boolean successfull = loginToXCast(driver, txtName.getText(), txtPassword.getText());
                if(successfull){
                    name = txtName.getText();
                    password = txtPassword.getText();
                    frameLogin.dispose();
                    showSnipeFrame(driver);
                }else{
                    lblMessage.setText("Login failed");
                }
            }
        });
        txtPassword.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boolean successfull = loginToXCast(driver, txtName.getText(), txtPassword.getText());
                if(successfull){
                    name = txtName.getText();
                    password = txtPassword.getText();
                    frameLogin.dispose();
                    showSnipeFrame(driver);
                }else{
                    lblMessage.setText("Login failed");
                }
            }
        });
        
        frameLogin.add(panelLogin);
        frameLogin.setVisible(true);
        
    }
    
    /**
     * Erzeugt Markeplace Sniper Frame
     * @param driver WebDriver im Shop
     */
    public void showSnipeFrame(WebDriver driver){
        JFrame frameSnipe = new JFrame("Snipe");
        frameSnipe.setSize(300, 300);
        frameSnipe.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        JPanel panelSnipe = new JPanel();
        panelSnipe.setLayout(new GridBagLayout());
        
        JLabel lblText = new JLabel("Text:");
        JTextField txtText = new JTextField();
        txtText.setPreferredSize(new Dimension(200, 30));
        panelSnipe.add(lblText,makeGridBagConstraint(1, 0, 0));
        panelSnipe.add(txtText, makeGridBagConstraint(1, 1, 0));
        
        
        JProgressBar progressBar = new JProgressBar(0, 50);
        JLabel lblMessage = new JLabel();
        panelSnipe.add(progressBar, makeGridBagConstraint(1, 0, 2, 2, 1));
        panelSnipe.add(progressBar, makeGridBagConstraint(1, 0, 2, 2, 1));
        
        JButton btnSnipe = new JButton("Snipe");
        panelSnipe.add(btnSnipe, makeGridBagConstraint(1, 0, 1, 2, 1));
        btnSnipe.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                snipe(panelSnipe, driver, txtText.getText(), progressBar, btnSnipe);
            }
        });
        txtText.addActionListener((e) -> {
                snipe(panelSnipe, driver, txtText.getText(), progressBar, btnSnipe);
        });
        
        frameSnipe.add(panelSnipe);
        frameSnipe.setVisible(true);
    }
    
    public void snipe(JPanel panel, WebDriver driver, String text, JProgressBar progressBar, JButton btn){
        
        progressBar.setValue(0);
        progressBar.setStringPainted(true);
        
        Thread t = new Thread(){
            @Override
            public void run() {
                btn.setEnabled(false);
                driver.navigate().refresh();
                System.out.println("Suche: "+text);
                for(int i=1; i<=progressBar.getMaximum(); i++){
                    progressBar.setValue(i);
                    progressBar.setString(""+i);
                    
                    try{
                        List<WebElement> elems = driver.findElements(By.xpath("//*[contains(text(), '"+text+"')]"));
                        if (driver instanceof JavascriptExecutor) {
                            for(WebElement elem: elems){
                                ((JavascriptExecutor)driver).executeScript("arguments[0].style.border='3px solid red'", elem);
                            }
                        }
                        if(elems.isEmpty()){
                            throw new Exception("Nix gefunden");
                        }
                        break;
                    }catch(Exception ex){
                        driver.navigate().refresh();
                    }
                    
                    
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }

                }
                btn.setEnabled(true);
            }
        };
        t.start();
    }
    
    
    //<editor-fold defaultstate="collapsed" desc="Utility">
    public boolean loginToXCast(WebDriver driver, String username, String password){
        try{
            driver.get("https://xcraftkkrieger.cx.edvschule-plattling.de/XCraft/");
            WebElement boxName = driver.findElement(By.name(Textbox.USERNAME.getNameString()));
            boxName.sendKeys(username);
            WebElement boxPassword = driver.findElement(By.name(Textbox.PASSWORD.getNameString()));
            boxPassword.sendKeys(password);
            WebElement btnLogin = driver.findElement(By.name(ButtonNavigate.LOGIN.getNameString()));
            btnLogin.click();
            WebElement btnXCast = driver.findElement(By.xpath("//input[@value='zum Schwarzmarkt-Händler']"));
            btnXCast.click();
            return true;
        }catch(Exception e){
            return false;
        }
    }
    
    public WebElement findWebElementByText(WebDriver driver, String text){
        WebElement elem = driver.findElement(By.xpath("//*[contains(text(), '"+text+"')]"));
        return elem;
    }
    
    private GridBagConstraints makeGridBagConstraint(int fill, int x, int y) {
        GridBagConstraints c = new GridBagConstraints();
        c.fill = fill;
        c.gridx = x;
        c.gridy = y;
        c.insets = new Insets(3, 3, 3, 3);
        return c;
    }
    
    private GridBagConstraints makeGridBagConstraint(int fill, int x, int y, int gridwidth, int gridheigt) {
        GridBagConstraints c = makeGridBagConstraint(fill, x, y);
        c.gridwidth = gridwidth;
        c.gridheight = gridheigt;
        return c;
    }
//</editor-fold>

}
