package xcraftbot.xcraftobjects;

import java.util.List;

public class Account {
    
//Attribute
    private String name;
    private String password;
    private List<XCharacter> xcharacters;
    private MaterialInventory materialInventory;
    private boolean loggedIn;

//Konstruktor
    public Account(){
        setLoggedIn(false);
        materialInventory=new MaterialInventory();
    }

//Getter und Setter
    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }
    public List<XCharacter> getXcharacters() {
        return xcharacters;
    }
    public void setXcharacters(List<XCharacter> xcharacters) {
        this.xcharacters = xcharacters;
    }
    public boolean isLoggedIn() {
        return loggedIn;
    }
    public void setLoggedIn(boolean loggedIn) {
        this.loggedIn = loggedIn;
    }
    public MaterialInventory getMaterialInventory() {
        return materialInventory;
    }
    public void setMaterialInventory(MaterialInventory materialInventory) {
        this.materialInventory = materialInventory;
    }
    public String getPassword() {
        return password;
    }
    public void setPassword(String password) {
        this.password = password;
    }
    
    
//ToString
    @Override
    public String toString() {
        return "Account{" + "name=" + name + ", xcharacters=" + xcharacters + ", materialInventory=" + materialInventory + ", loggedIn=" + loggedIn + '}';
    }

    
    

    
    
}
