package xcraftbot.xcraftobjects;

import java.util.ArrayList;
import java.util.List;

public class XCharacter {
    
    
    // <editor-fold defaultstate="collapsed" desc=" Region: Attributes ">
    private String name;
    private Inventory equipment;
    private int craftedCount;
    private int fightCount;
    private int winCount;
    private int killCount;

    //Stats
    private int gesundheit;
    private int maxGesundheit;
    private int angriff;
    private int angriffCharacter;
    private int angriffItems;
    private int verteidigung;
    private int verteidigungCharacter;
    private int verteidigungItems;
    private int schaden;
    private int schadenCharacter;
    private int schadenItems;
    private int ruestung;
    private int ruestungCharacter;
    private int ruestungItems;

    //Cratfing
    private boolean crafting;
    private int timeInSec;
    private List<Recipe> recipes;

    //XPaths
    private String xpathName;
    private String xpathBericht;

// </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc=" Region: Constructors ">
    public XCharacter() {
        recipes = new ArrayList<>();
        equipment = new Inventory();
    }

// </editor-fold>

    // <editor-fold defaultstate="collapsed" desc=" Region: Getter und Setter ">
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public Inventory getEquipment() {
        return equipment;
    }
    
    public void setEquipment(Inventory equipment) {
        this.equipment = equipment;
    }
    
    public int getCraftedCount() {
        return craftedCount;
    }
    
    public void setCraftedCount(int craftedCount) {
        this.craftedCount = craftedCount;
    }
    
    public int getFightCount() {
        return fightCount;
    }
    
    public void setFightCount(int fightCount) {
        this.fightCount = fightCount;
    }
    
    public int getWinCount() {
        return winCount;
    }
    
    public void setWinCount(int winCount) {
        this.winCount = winCount;
    }
    
    public int getKillCount() {
        return killCount;
    }
    
    public void setKillCount(int killCount) {
        this.killCount = killCount;
    }
    
    public int getGesundheit() {
        return gesundheit;
    }
    
    public void setGesundheit(int gesundheit) {
        this.gesundheit = gesundheit;
    }
    
    public int getMaxGesundheit() {
        return maxGesundheit;
    }
    
    public void setMaxGesundheit(int maxGesundheit) {
        this.maxGesundheit = maxGesundheit;
    }
    
    public int getAngriff() {
        return angriff;
    }
    
    public void setAngriff(int angriff) {
        this.angriff = angriff;
    }
    
    public int getAngriffCharacter() {
        return angriffCharacter;
    }
    
    public void setAngriffCharacter(int angriffCharacter) {
        this.angriffCharacter = angriffCharacter;
    }
    
    public int getAngriffItems() {
        return angriffItems;
    }
    
    public void setAngriffItems(int angriffItems) {
        this.angriffItems = angriffItems;
    }
    
    public int getVerteidigung() {
        return verteidigung;
    }
    
    public void setVerteidigung(int verteidigung) {
        this.verteidigung = verteidigung;
    }
    
    public int getVerteidigungCharacter() {
        return verteidigungCharacter;
    }
    
    public void setVerteidigungCharacter(int verteidigungCharacter) {
        this.verteidigungCharacter = verteidigungCharacter;
    }
    
    public int getVerteidigungItems() {
        return verteidigungItems;
    }
    
    public void setVerteidigungItems(int verteidigungItems) {
        this.verteidigungItems = verteidigungItems;
    }
    
    public int getSchaden() {
        return schaden;
    }
    
    public void setSchaden(int schaden) {
        this.schaden = schaden;
    }
    
    public int getSchadenCharacter() {
        return schadenCharacter;
    }
    
    public void setSchadenCharacter(int schadenCharacter) {
        this.schadenCharacter = schadenCharacter;
    }
    
    public int getSchadenItems() {
        return schadenItems;
    }
    
    public void setSchadenItems(int schadenItems) {
        this.schadenItems = schadenItems;
    }
    
    public int getRuestung() {
        return ruestung;
    }
    
    public void setRuestung(int ruestung) {
        this.ruestung = ruestung;
    }
    
    public int getRuestungCharacter() {
        return ruestungCharacter;
    }
    
    public void setRuestungCharacter(int ruestungCharacter) {
        this.ruestungCharacter = ruestungCharacter;
    }
    
    public int getRuestungItems() {
        return ruestungItems;
    }
    
    public void setRuestungItems(int ruestungItems) {
        this.ruestungItems = ruestungItems;
    }
    
    public boolean isCrafting() {
        return crafting;
    }
    
    public void setCrafting(boolean crafting) {
        this.crafting = crafting;
    }
    
    public int getTimeInSec() {
        return timeInSec;
    }
    
    public void setTimeInSec(int timeInSec) {
        this.timeInSec = timeInSec;
    }
    
    public String getXpathName() {
        return xpathName;
    }
    
    public void setXpathName(String xpathName) {
        this.xpathName = xpathName;
    }
    
    public String getXpathBericht() {
        return xpathBericht;
    }
    
    public void setXpathBericht(String xpathBericht) {
        this.xpathBericht = xpathBericht;
    }
    
    public List<Recipe> getRecipes() {
        return recipes;
    }
    
    public void setRecipes(List<Recipe> recipes) {
        this.recipes = recipes;
    }

// </editor-fold>
    
    // <editor-fold defaultstate="collapsed" desc=" Region: Default Methods ">
    @Override
    public String toString() {
        return "Character{" + "name=" + name + ", equipment=" + equipment + ", craftedCount=" + craftedCount + ", fightCount=" + fightCount + ", winCount=" + winCount + ", killCount=" + killCount + ", gesundheit=" + gesundheit + ", maxGesundheit=" + maxGesundheit + ", angriff=" + angriff + ", angriffCharacter=" + angriffCharacter + ", angriffItems=" + angriffItems + ", verteidigung=" + verteidigung + ", verteidigungCharacter=" + verteidigungCharacter + ", verteidigungItems=" + verteidigungItems + ", schaden=" + schaden + ", schadenCharacter=" + schadenCharacter + ", schadenItems=" + schadenItems + ", ruestung=" + ruestung + ", ruestungCharacter=" + ruestungCharacter + ", ruestungItems=" + ruestungItems + ", crafting=" + crafting + ", timeInSec=" + timeInSec + '}';
    }

// </editor-fold>
    
}
