package xcraftbot.xcraftobjects;

public class Geldmenge {
    
    private int kupfer;
    private int silber;
    private int gold;
    private int platin;

    public Geldmenge(int kupfer, int silber, int gold, int platin) {
        setPlatin(platin);
        setGold(gold);
        setSilber(silber);
        setKupfer(kupfer);
    }
    
    public Geldmenge(int kupfer){
        setPlatin(0);
        setGold(0);
        setSilber(0);
        setKupfer(kupfer);
    }

    private int getKupfer() {
        return kupfer;
    }

    private void setKupfer(int kupfer) {
        if(kupfer>=10){
            setSilber(getSilber()+kupfer/10);
            this.kupfer=kupfer%10;
        }else{
            this.kupfer = kupfer;
        }
    }

    private int getSilber() {
        return silber;
    }

    private void setSilber(int silber) {
        if(silber>=100){
            setGold(getGold()+silber/100);
            this.silber=silber%100;
        }else{
            this.silber = silber;
        }
    }
    
    private int getGold() {
        return gold;
    }

    private void setGold(int gold) {
        if(gold>=1000){
            setPlatin(getPlatin()+gold/1000);
            this.gold=gold%1000;
        }else{
            this.gold = gold;
        }
    }

    private int getPlatin() {
        return platin;
    }

    private void setPlatin(int platin) {
        this.platin = platin;
    }
    
    public int getKupferValue(){
        return getKupfer()+(getSilber()*10)+(getGold()*100)+(getGold()*1000);
    }

    @Override
    public String toString() {
        return "Geldmenge{" + "kupfer=" + kupfer + ", silber=" + silber + ", gold=" + gold + ", platin=" + platin + '}';
    }
    
    
    
}
